<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Eddie: EddieResource Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Eddie
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classEddieResource-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">EddieResource Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ab0d354d94f9e1ce71597b8e842850441"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structmessage__t.html">message_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEddieResource.html#ab0d354d94f9e1ce71597b8e842850441">render_get</a> (<a class="el" href="structrequest__t.html">request_t</a> &amp;request)</td></tr>
<tr class="separator:ab0d354d94f9e1ce71597b8e842850441"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad14a722575480386f40592d281c70d43"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structmessage__t.html">message_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEddieResource.html#ad14a722575480386f40592d281c70d43">render_post</a> (<a class="el" href="structrequest__t.html">request_t</a> &amp;request)</td></tr>
<tr class="separator:ad14a722575480386f40592d281c70d43"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a78e82350f95b96a67f53525f687ecf33"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structmessage__t.html">message_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEddieResource.html#a78e82350f95b96a67f53525f687ecf33">render_put</a> (<a class="el" href="structrequest__t.html">request_t</a> &amp;request)</td></tr>
<tr class="separator:a78e82350f95b96a67f53525f687ecf33"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a02255eac7ca0bf2772e3fe8456f2b9f3"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structmessage__t.html">message_t</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEddieResource.html#a02255eac7ca0bf2772e3fe8456f2b9f3">render_delete</a> (<a class="el" href="structrequest__t.html">request_t</a> &amp;request)</td></tr>
<tr class="separator:a02255eac7ca0bf2772e3fe8456f2b9f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7d22791c7affe5f78618ef7b7a3210e1"><td class="memItemLeft" align="right" valign="top">virtual const char *const  *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEddieResource.html#a7d22791c7affe5f78618ef7b7a3210e1">get_path</a> ()</td></tr>
<tr class="separator:a7d22791c7affe5f78618ef7b7a3210e1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab36287546947cd2c17568edc03b5b271"><td class="memItemLeft" align="right" valign="top">virtual const char *const  *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEddieResource.html#ab36287546947cd2c17568edc03b5b271">get_attributes</a> ()</td></tr>
<tr class="separator:ab36287546947cd2c17568edc03b5b271"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a203644c1302f27ae36425ab045c7396b"><td class="memItemLeft" align="right" valign="top"><a id="a203644c1302f27ae36425ab045c7396b"></a>
<a class="el" href="structmessage__t.html">message_t</a>&#160;</td><td class="memItemRight" valign="bottom"><b>request_handler</b> (<a class="el" href="structrequest__t.html">request_t</a> &amp;request)</td></tr>
<tr class="separator:a203644c1302f27ae36425ab045c7396b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aed587427bcbc0ce8907f3e17cf729523"><td class="memItemLeft" align="right" valign="top"><a id="aed587427bcbc0ce8907f3e17cf729523"></a>
std::string&#160;</td><td class="memItemRight" valign="bottom"><b>get_path_str</b> ()</td></tr>
<tr class="separator:aed587427bcbc0ce8907f3e17cf729523"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac9b24b84b34260cf6f48b49fce90a8e9"><td class="memItemLeft" align="right" valign="top"><a id="ac9b24b84b34260cf6f48b49fce90a8e9"></a>
std::vector&lt; std::string &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>get_attributes_str</b> ()</td></tr>
<tr class="separator:ac9b24b84b34260cf6f48b49fce90a8e9"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ab36287546947cd2c17568edc03b5b271"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab36287546947cd2c17568edc03b5b271">&#9670;&nbsp;</a></span>get_attributes()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual const char* const* EddieResource::get_attributes </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Implement this method to return the resource attributes </p><dl class="section return"><dt>Returns</dt><dd>resource attributes as an array of C-strings terminated by nullptr. For example the attributes "lt=90000&amp;rt=eddie.lamp" is returned as ["lt=90000", "rt=eddie.lamp", nullptr] </dd></dl>

</div>
</div>
<a id="a7d22791c7affe5f78618ef7b7a3210e1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7d22791c7affe5f78618ef7b7a3210e1">&#9670;&nbsp;</a></span>get_path()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual const char* const* EddieResource::get_path </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Implement this method to return the resource path </p><dl class="section return"><dt>Returns</dt><dd>resource path as an array of C-strings terminated by nullptr. For example the path "lamp/brightness" is returned as ["lamp", "brightness", nullptr] </dd></dl>

</div>
</div>
<a id="a02255eac7ca0bf2772e3fe8456f2b9f3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a02255eac7ca0bf2772e3fe8456f2b9f3">&#9670;&nbsp;</a></span>render_delete()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structmessage__t.html">message_t</a> EddieResource::render_delete </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structrequest__t.html">request_t</a> &amp;&#160;</td>
          <td class="paramname"><em>request</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Implement this method to define a delete handler </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">request</td><td>The DELETE request data </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Response to the DELETE request </dd></dl>

</div>
</div>
<a id="ab0d354d94f9e1ce71597b8e842850441"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab0d354d94f9e1ce71597b8e842850441">&#9670;&nbsp;</a></span>render_get()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structmessage__t.html">message_t</a> EddieResource::render_get </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structrequest__t.html">request_t</a> &amp;&#160;</td>
          <td class="paramname"><em>request</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Implement this method to define a get handler </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">request</td><td>The GET request data </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Response to the GET request </dd></dl>

</div>
</div>
<a id="ad14a722575480386f40592d281c70d43"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad14a722575480386f40592d281c70d43">&#9670;&nbsp;</a></span>render_post()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structmessage__t.html">message_t</a> EddieResource::render_post </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structrequest__t.html">request_t</a> &amp;&#160;</td>
          <td class="paramname"><em>request</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Implement this method to define a post handler </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">request</td><td>The POST request data </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Response to the POST request </dd></dl>

</div>
</div>
<a id="a78e82350f95b96a67f53525f687ecf33"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a78e82350f95b96a67f53525f687ecf33">&#9670;&nbsp;</a></span>render_put()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structmessage__t.html">message_t</a> EddieResource::render_put </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structrequest__t.html">request_t</a> &amp;&#160;</td>
          <td class="paramname"><em>request</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Implement this method to define a put handler </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">request</td><td>The PUT request data </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Response to the PUT request </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/builds/eclipse/oniro-core/eddie/common/include/<a class="el" href="eddie_8h_source.html">eddie.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
